//******************************************************************************
// File Name            :  mandelbrot_ip.c
//------------------------------------------------------------------------------
// Function             :  mandelbrot
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//------------------------------------------------------------------------------
// History
// -.-- 2016/10/14
//******************************************************************************
#include <ap_cint.h>
#define XP_MAX 320 //ősNZ
#define YP_MAX 240 //cősNZ
#define M_SIZE XP_MAX*YP_MAX //zTCY
#define I_MAX 255 //ő僋[v
#define E 4.0
void mandelbrot_ip(uint12 d[M_SIZE] ,uint12 c, uint8 cr_s, uint8 cr_e, uint8 ci_s,uint8 ci_e){
  int xp,yp;
  short color;
  double Cr_s; //Jn
  double Cr_e; //I
  double Ci_s; //Jn
  double Ci_e; //I
  signed char uc_cr_s;
  signed char uc_cr_e;
  signed char uc_ci_s;
  signed char uc_ci_e;
  double Cr,Ci;
  double diff_Cr,diff_Ci;
  double zr,zi,zrN,ziN;
  int i;
  int c1,c2,c3;
  uc_cr_s = (unsigned char)(cr_s);
  uc_cr_e = (unsigned char)(cr_e);
  uc_ci_s = (unsigned char)(ci_s);
  uc_ci_e = (unsigned char)(ci_e);
  Cr_s = ((double)uc_cr_s)/64;
  Cr_e = ((double)uc_cr_e)/64;
  Ci_s = ((double)uc_ci_s)/64;
  Ci_e = ((double)uc_ci_e)/64;
  diff_Cr=(Cr_e-Cr_s)/XP_MAX;
  diff_Ci=(Ci_e-Ci_s)/YP_MAX;
  Ci=Ci_s;
  Cr=Cr_s;
  loop1:for(yp=0;yp<YP_MAX;yp++){ //cړ
    loop2:for(xp=0;xp<XP_MAX;xp++){ //ړ
      zr=0.0;
      zi=0.0;
      loop3:for(i=0;i<I_MAX;i++){ //QZ񐔃JEg
        zrN=zr*zr-zi*zi+Cr; //QvZ
        ziN=2.0*zr*zi+Ci; //QvZ
        if (zrN>E) break; //U
        if(ziN>E ) break; //U
        zr=zrN;
        zi=ziN;
      }
      //Fw
      if(i>32) c1 = 15;
      else c1 = i/2;
      if(i>64) c2 = 15;
      else c2 = i/4;
        c3 = i/16;
      if(c==0x1) color = c1 + c3*16 + c3*256;
      else if(c==0x2)
        color = c3 + c1*16 + c3*256;
      else if(c==0x3)
        color = c3 + c2*16 + c1*256;
      else
        color = c1 + c1*16 + c1*256 + i*256;
    d[xp+yp*320]= color;//
    Cr+=diff_Cr;
    }
  Cr=Cr_s;
  Ci+=diff_Ci;
  }
}
