//******************************************************************************
// File Name            :  hls_blk.v
//------------------------------------------------------------------------------
// Function             :  hls_blk
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//------------------------------------------------------------------------------
// History
// -.-- 2016/10/14
//******************************************************************************
module hls_blk(
  clk_100m,
  clk,
  rst,
  h_c_en,
  v_c,
  h_c,
  sw_mov,
  sw_mode,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b
);

  input clk_100m;
  input clk;
  input rst;
  input h_c_en;
  input [9:0] v_c;
  input [9:0] h_c;
  input [4:0]sw_mov;
  input [2:0]sw_mode;
  output gen_da_en;
  output [7:0]gen_da_r;
  output [7:0]gen_da_g;
  output [7:0]gen_da_b;

  reg gen_da_en;
  reg [7:0]gen_da_r;
  reg [7:0]gen_da_g;
  reg [7:0]gen_da_b;         
  
  /*
    wire [7:0]gen_da_r;
    wire [7:0]gen_da_g;
    wire [7:0]gen_da_b;           
  */
wire out_bit;
wire d_we0;
wire d_ce0;
wire[16:0]d_address0;
wire [11 : 0] d_d0;
reg [16:0]addrb;
wire [11:0]doutb;
reg ap_start;
wire ap_done;
wire ap_idle;
wire ap_ready;
wire [31:0]x1;
wire [31:0]y1;
wire [31:0]x2;
wire [31:0]y2;
wire [11:0]c;

reg [7:0]cr_s;
reg [7:0]cr_e;
reg [7:0]ci_s;
reg [7:0]ci_e;

wire sw_en;
wire [4:0] sw_o;
reg [1:0] cnt;

assign x1= 10;
assign y1= 10;
assign x2= 100;
assign y2= 100;

sw_if sw_if(
  .clk_100m(clk_100m),
  .rst(rst),
  .sw(sw_mov),
  .sw_o(sw_o));

always @ (posedge clk_100m )
  if(rst==1'b1) begin
    cr_s<=8'he0;
    cr_e<=8'h0d;
    ci_s<=8'hBD;
    ci_e<=8'hdd;
  end
  else begin 
    if(sw_o[0]==1'b1)begin
      ci_s<=ci_s - 8'h4;
      ci_e<=ci_e - 8'h4;
    end
    else if(sw_o[2]==1'b1)begin
      ci_s<=ci_s + 8'h4;
      ci_e<=ci_e + 8'h4;
    end
    else if(sw_o[1]==1'b1)begin
      cr_s<=cr_s + 8'h4;
      cr_e<=cr_e + 8'h4;
    end
    else if(sw_o[3]==1'b1)begin
      cr_s<=cr_s - 8'h4;
      cr_e<=cr_e - 8'h4;
    end
    else if(sw_o[4]==1'b1)begin
	  if(sw_mode[0]==1'b1)begin
        ci_s<=ci_s + 8'h4;
        ci_e<=ci_e - 8'h4;
        cr_s<=cr_s + 8'h4;
        cr_e<=cr_e - 8'h4;
	  end
	  else begin
        ci_s<=ci_s - 8'h4;
        ci_e<=ci_e + 8'h4;
        cr_s<=cr_s - 8'h4;
        cr_e<=cr_e + 8'h4;
      end
	end
    else begin
      cr_s<=cr_s ;
      cr_e<=cr_e ;
      ci_s<=ci_s ;
      ci_e<=ci_e ;
    end
 end

always @ (posedge clk_100m )
  if(rst==1'b1)
    ap_start <= 1'b0;
  else
    if (sw_o==5'h00)
      ap_start <= 1'b0;
    else
      ap_start <= 1'b1;
         
             
  always @ (posedge clk_100m )
    if(rst==1)
      cnt <= 2'b00;
    else
      if  (sw_o[0]==1'b1)    
          cnt <= cnt + 2'b01;
      else
        cnt <= cnt;
   
assign c = (cnt==2'b01)?12'h00f:
           (cnt==2'b10)?12'h0f0:
           (cnt==2'b11)?12'hf00:
                        12'hfff;    
                        
ram_if_ip_0 ram_if_ip_0_0 (
  .d_ce0(d_ce0),            // output wire d_ce0
  .d_we0(d_we0),            // output wire d_we0
  .ap_clk(clk_100m),          // input wire ap_clk
  .ap_rst( rst),          // input wire ap_rst
  .ap_start(ap_start),      // input wire ap_start
  .ap_done(ap_done),        // output wire ap_done
  .ap_idle(ap_idle),        // output wire ap_idle
  .ap_ready(ap_ready),      // output wire ap_ready
  .d_address0(d_address0),  // output wire [16 : 0] d_address0
  .d_d0(d_d0),              // output wire [11 : 0] d_d0
  .color(c)                    // input wire [11 : 0] c
);
/*
assign c = (sw_mode[2:1]==2'b01)?12'h001:
           (sw_mode[2:1]==2'b10)?12'h002:
           (sw_mode[2:1]==2'b11)?12'h003:
                      12'hfff;
           
mandelbrot_ip_0 mandelbrot_ip_0 (
  .d_ce0(d_ce0),            // output wire d_ce0
  .d_we0(d_we0),            // output wire d_we0
  .ap_clk(clk_100m),          // input wire ap_clk
  .ap_rst( rst),          // input wire ap_rst
  .ap_start(ap_start),      // input wire ap_start
  .ap_done(ap_done),        // output wire ap_done
  .ap_idle(ap_idle),        // output wire ap_idle
  .ap_ready(ap_ready),      // output wire ap_ready
  .d_address0(d_address0),  // output wire [16 : 0] d_address0
  .d_d0(d_d0),              // output wire [11 : 0] d_d0
  .c(c),                    // input wire [11 : 0] c
  .cr_s(cr_s),
  .cr_e(cr_e),
  .ci_s(ci_s),
  .ci_e(ci_e)
);
*/
video_ram video_ram(
.clka(clk_100m),
.wea(d_we0),
.addra(d_address0),
.dina(d_d0),
.clkb(clk),
.addrb(addrb),
.doutb(doutb)
);

always @ (posedge clk )
  //if((h_c<320)&&(v_c<240))
  if((h_c>=160)&&(h_c<480)&&(v_c>=120)&&(v_c<360))
     addrb <= (v_c-10'd120)*320 + (h_c-10'd160);
  else
     addrb <= 17'h0000;

always @ (posedge clk )
if (rst==1'b1) 
  begin
    gen_da_en <= 1'b0; 
  end
else
  //if((h_c_en==1'b1)&&(h_c<320)&&(v_c<240))
  if((h_c_en==1'b1)&&(h_c>=160)&&(h_c<480)&&(v_c>=120)&&(v_c<360))
    gen_da_en <= 1'b1;
  else
    gen_da_en <= 1'b0 ;

always @ (posedge clk  )
if (rst==1'b1) 
  begin
    //gen_da_en <= 1'b0; 
    gen_da_r <= 8'd0;
    gen_da_g <= 8'd0;
    gen_da_b <= 8'd0;
  end
else
  //if((h_c_en==1'b1)&&(h_c<320)&&(v_c<240))
  if((h_c_en==1'b1)&&(h_c>=160)&&(h_c<480)&&(v_c>=120)&&(v_c<360))
    begin      //gen_da_en <= 1'b1;
      gen_da_r <= {doutb[3:0],4'b0000};
      gen_da_g <= {doutb[7:4],4'b0000};
      gen_da_b <= {doutb[11:8],4'b0000};
    end  
  else
    begin
      //gen_da_en <= 1'b0 ;
      gen_da_r <= 8'd0;
      gen_da_g <= 8'd0;
      gen_da_b <= 8'd0;
    end

endmodule








